<?php

namespace Pkol\Leasing\Controller\Index;

use Pkol\Leasing\Model\Taxrate;
use \Magento\Tax\Model\Calculation\Rate;

class LeasingWidget extends \Magento\Framework\App\Action\Action
{

    public $helper;
    protected $helperData;
    public $shopid;
    public $secretkey;
    public $env;
    public $widget_style;
    public $widget_size;
    public $widget_rate;
    public $client;
    public $_path;
    public $enable;


    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Pkol\Leasing\Helper\Data $helperData

    ) {
        $this->helper = $helperData;
        $this->shopid = $helperData->getGeneralConfig('shopID');
        $this->enable = $helperData->getGeneralConfig('enable');
        $this->secretkey = $helperData->getGeneralConfig('secretKey');
        $this->env = $helperData->getGeneralConfig('env');
        $this->widgetproduct = $helperData->getGeneralConfig('widgetproduct');
        $this->widgetorder = $helperData->getGeneralConfig('widgetorder');
        $this->widgetcart = $helperData->getGeneralConfig('widgetcart');
        $this->widget_style = $helperData->getGeneralConfig('widgetstyle');
        $this->widget_size = $helperData->getGeneralConfig('widgetsize');
        $this->widget_rate = $helperData->getGeneralConfig('widgetrate');
        $this->_path = '/app/code/Pkol/Leasing/view/frontend/web/images/';
        $this->prod_url = 'https://pc.pkoleasing.pl';
        $this->test_url = 'https://stpc.pkoleasing.pl';
        $this->lease_url = '/leasing/init';
        $this->endpoint = '/leasing/public/plugin/simulation';
        $this->app_status = true;
        if ($this->env == 0) {
            $this->lease_url = $this->test_url . $this->lease_url;
        } else {
            $this->lease_url = $this->prod_url . $this->lease_url;
            $this->test_url = $this->prod_url;
        }
        // $this->client = new \GuzzleHttp\Client();

        return parent::__construct($context);
    }
    public function getRate($tax)
    {
        $tax = explode('.', $tax);
        $taxes = [
            '0%' => 1,
            '7%' => 2,
            '8%' => 3,
            '22%' => 4,
            '23%' => 5,
            '23' => 5,
            '22' => 4,
            '8' => 3,
            '7' => 2,
            '0' => 1
        ];
        $tax = $tax[0];

        if (isset($taxes[$tax])) {
            return $taxes[$tax];
        } else {
            return null;
        }
    }
    public function validateProduct($data)
    {
        $pid = $data['pid'];
        $type = $data['type'];
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $product = $objectManager->create('Magento\Catalog\Model\Product')->load($pid);
        $product_name = $product->getName();
        $category = $product->getCategoryId();
    }
    public function testConnection()
    {
        $settings_token = $this->shopid . ':' . $this->secretkey;
        $token = base64_encode($settings_token);

        $this->client = new \GuzzleHttp\Client([
            'verify' => false,
            'exceptions ' => false,
            'headers' => ['Content-Type' => 'application/json', 'Authorization' => 'Bearer ' . $token, 'verify' => false]
        ]);
        $test = [
            'shopId' => 1,
            'widgetOption' => 2,
            'totalNetValue' => 1000,
            'uniqueItemQuantity' => 1,
            'source' => "BASKET",
            'products' => [
                [
                    'categoryId' => '475',
                    'quantity' => 1,
                    'netValue' => 1000,
                    'vatRate' => 0
                ]
            ]
        ];

        $data = json_encode($test);

        $response = $this->client->post(
            $this->test_url . $this->endpoint,
            [
                'headers' => ['Content-Type' => 'application/json', 'Authorization' => 'Bearer ' . $token, 'verify' => false],
                'body' => $data,
                'connect_timeout' => 5, // Connection timeout,
                'verify' => false,
                'exceptions' => false,
                'http_errors' => false

            ],
        );
        if ($response && $response->getStatusCode() == 200) {
            $response = 'ok';
        } else {
            $response = 'failed';
        }
       
        return $response;
    }

    public function getForm($type, $data, $returnUrl)
    {

        $url = $returnUrl;
        if ($type == 'BASKET') {
            $url = 'https://' . $_SERVER['HTTP_HOST'] . '/checkout/cart/';
        }
        $products_counter = count($data['products']);


        $form = '<form id="pkol_form" action="' . $this->lease_url . '" id="leasing" method="POST">';
        $form .= '<input type="hidden" name="shopId" value="' . $this->shopid . '" />';
        $form .= '<input type="hidden" name="returnLink" value="' . $url . '" />';
        $form .= '<input type="hidden" name="uniqueItemQuantity" value="' . $products_counter . '" />';
        $n = 1;
        $total_wt = 0;
        $total_ex_tax = 0;

        foreach ($data['products'] as $p) {

            $form .= '<input type="hidden" name="productName' . $n . '" value="' . $p['product_name'] . '" />';
            $form .= '<input type="hidden" name="productPrice' . $n . '" value="' . str_replace(',', '', number_format($p['product_price_with_tax'], 2)) . '" />';
            $form .= '<input type="hidden" name="productNetPrice' . $n . '" value="' . str_replace(',', '', number_format($p['netValue'], 2)) . '" />';
            $form .= '<input type="hidden" name="productQuantity' . $n . '" value="' . $p['quantity'] . '" />';
            $form .= '<input type="hidden" name="productCategory' . $n . '" value="' . $p['categoryId'] . '" />';
            $form .= '<input type="hidden" name="productVatRate' . $n . '" value="' . $p['vatRate'] . '" />';
            $total_wt = $total_wt + ($p['quantity'] * $p['netValue']);
            $total_ex_tax = $total_ex_tax + ($p['quantity'] * $p['product_price_with_tax']);
            $n++;
        }
        
        $form .= '<input type="hidden" name="totalValue" value="' . str_replace(',', '', number_format($total_ex_tax, 2)) . '" />';
        $form .= '<input type="hidden" name="totalNetValue" value="' . str_replace(',', '', number_format($total_wt, 2)) . '" />';
        $form .= '<input type="hidden" name="source" value="' . $type . '" />';
        //  $form .= '<button type="submit" name="credit" form="pkol_form">Test</button>';
        $form .= '</form>';

        return $form;
    }
    public function validateProducts($type, $pid)
    {
        $total = 0;
        $settings_token = $this->shopid . ':' . $this->secretkey;
        $token = base64_encode($settings_token);
        $this->client = new \GuzzleHttp\Client([
            'verify' => false,
            'exceptions ' => false,
            'headers' => ['Content-Type' => 'application/json', 'Authorization' => 'Bearer ' . $token, 'verify' => false]
        ]);
       
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        switch ($type) {
            case 'ITEM':
                if ($this->widgetproduct == 0) {
                    return false;
                }
               
                $product = $objectManager->create('Magento\Catalog\Model\Product')->load($pid);
                if ($product->getTypeId() !== 'simple') {
                    return false;
                }
              
                $stockItem = $product->getExtensionAttributes()->getStockItem();
                $stockQty = $stockItem->getQty(); // $stockItemData = $stockItem->getData();
                $url = $product->getProductUrl();

                if ((int) $stockQty < 1) {
                    return false;
                }
                $product_name = $product->getName();
                $category = $product->getCategoryIds();
                $product_category = $category[0];
                // product tax class id
                $tax_class_id = $product->getTaxClassId();
             

                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $taxCalculation = $objectManager->create('Magento\Tax\Model\Calculation\Rate');
                $config = $objectManager->create('Magento\Framework\App\Config\ScopeConfigInterface');
                /** @var \Magento\Framework\App\Config\ScopeConfigInterface $config */
                $countryCode = $config->getValue(\Magento\Shipping\Model\Config::XML_PATH_ORIGIN_COUNTRY_ID);

                $customerTaxClassId = $config->getValue('tax/classes/default_customer_tax_class');
              
                $rate = $taxCalculation->getRate(
                    new \Magento\Framework\DataObject(
                        [
                            'country_id' => $countryCode,                          
                            'customer_class_id' => $customerTaxClassId,
                            'product_class_id' => $tax_class_id
                        ]
                    )
                );
            
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();

                $taxCalculation = $objectManager->create('Magento\Tax\Model\Calculation\Rate')->load($tax_class_id, 'tax_calculation_rate_id');
                
                $rate = $taxCalculation->getRate();
                
                $priceWithTax = $product->getPriceInfo()->getPrice('final_price')->getMinimalPrice()->getValue();

                
                $priceWithoutTaxNotRound = number_format((float)$product->getPriceInfo()->getPrice('final_price')->getAmount()->getBaseAmount(),2,'.','');
                $priceWithTaxNotRound = number_format((float)$product->getPriceInfo()->getPrice('final_price')->getAmount()->getValue(), 2, '.','');
                
                // echo '<pre>';
                // var_dump($product->getPriceInfo()->getPrice('final_price')->getAmount()->getTax());
                // echo '</pre>';
             
                $tax = (($priceWithTaxNotRound * 100) / $priceWithoutTaxNotRound) - 100;
                $rate = round($tax);


                $tax_rate = $this->getRate($rate);
             
                $priceWithTax = $product->getPriceInfo()->getPrice('final_price')->getMinimalPrice()->getValue();
                $taxParameter = (100 + (int)$rate) / 100;
                $priceWithoutTax = round($priceWithTax / $taxParameter, 2);
                $test = [
                    'shopId' => $this->shopid,
                    'widgetOption' => 1,
                    'totalNetValue' =>  str_replace(',', '', number_format($priceWithoutTax, 2)),
                    'uniqueItemQuantity' => 1,
                    'source' => 'ITEM',
                    'products' => [
                        [
                            'categoryId' =>  $product_category,
                            'quantity' => 1,
                            'netValue' => str_replace(',', '', number_format($priceWithoutTax, 2)),
                            'vatRate' => $tax_rate
                        ]
                    ]
                ];

                $default_data = $test;
                foreach ($default_data['products'] as $key => $value) {
                    $default_data['products'][$key]['product_name'] = $product_name;
                    $default_data['products'][$key]['product_price_with_tax'] = $priceWithTax;
                    $default_data['products'][$key]['product_price_tax'] = $taxParameter;
                }

                break;
            case 'BASKET':
                
                
                $cart = $objectManager->get('\Magento\Checkout\Model\Cart');
                // retrieve quote items collection
                $itemsCollection = $cart->getQuote()->getItemsCollection();
                $discounts = $cart->getQuote()->getAppliedRuleIds();
                $items = $cart->getQuote()->getAllItems();
                $products = []; 
                
                foreach ($items as $item) {
                    $pid = $item->getProductId();
                 
                    $price_wtax = $item->getPrice();
                    $product = $objectManager->create('Magento\Catalog\Model\Product')->load($pid);
                    if ($product->getTypeId() !== 'simple') {
                        return false;
                    }
                    $product_name = $product->getName();
                    $stockItem = $product->getExtensionAttributes()->getStockItem();
                    $stockQty = $stockItem->getQty(); // $stockItemData = $stockItem->getData();
                    $url = $product->getProductUrl();
                    $category = $product->getCategoryIds();
                    $product_category = $category[0];
                    // product tax class id
                    $tax_class_id = $product->getTaxClassId();
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $taxCalculation = $objectManager->create('Magento\Tax\Model\Calculation\Rate')->load($tax_class_id, 'tax_calculation_rate_id');
                    // Tax
                    //fake rate
                    $tax_rate = $taxCalculation->getRate();
                    // $tax_rate = 8;
                   
                    $priceWithTax = $product->getPriceInfo()->getPrice('final_price')->getMinimalPrice()->getValue();

                    $priceWithoutTaxNotRound = number_format((float)$product->getPriceInfo()->getPrice('final_price')->getAmount()->getBaseAmount(),2,'.','');
                    $priceWithTaxNotRound = number_format((float)$product->getPriceInfo()->getPrice('final_price')->getAmount()->getValue(), 2, '.','');
                    
                    // echo '<pre>';
                    // var_dump($product->getPriceInfo()->getPrice('final_price')->getAmount()->getTax());
                    // echo '</pre>';
                
                    $tax = (($priceWithTaxNotRound * 100) / $priceWithoutTaxNotRound) - 100;
                    $tax_rate = round($tax);

                    $rate = $this->getRate($tax_rate);
                    $taxParameter = (100 + (int)$tax_rate) / 100;
                    $priceWithoutTax = str_replace(',', '', round($priceWithTax / $taxParameter, 2));
                  
                    $tmp = [
                        'categoryId' =>  $product_category,
                        'netValue' => str_replace(',', '', number_format($priceWithoutTax, 2)),
                        'vatRate' => $rate,
                        'quantity' => (int)$item->getQty(),
                        'product_name' => $product_name,
                        'product_price_with_tax' => $priceWithTax,
                        'product_price_tax' => $rate
                   ];
                   
                    array_push($products, $tmp);
                  
                 
                    $total = $total + (str_replace(',', '', number_format($priceWithoutTax, 2)) * (int)$item->getQty());
                }
                
                $test = [
                    'shopId' => $this->shopid,
                    'widgetOption' => 1,
                    'totalNetValue' =>  $total,
                    'uniqueItemQuantity' => count($products),
                    'source' => 'BASKET',
                    'products' => $products
                ];
             
                $default_data = $test;
                // foreach ($default_data['products'] as $key => $value) {
                //     $default_data['products'][$key]['product_name'] = $product_name;
                //     $default_data['products'][$key]['product_price_with_tax'] = $priceWithTax;
                //     $default_data['products'][$key]['product_price_tax'] = $taxParameter;
                // }


                break;
        }

        $data =  json_encode($test);

        $check_vat = json_decode($data);
        $taxRate = true;

        foreach ($check_vat->products as $v) {

            if ($v->vatRate == null) {
                $taxRate = false;
            }
        }
        if ($taxRate) {
            if ($type == 'BASKET') {
                foreach ($test['products'] as $key => $value) {
                    // unset($test['products'][$key]['product_name']);
                    // unset($test['products'][$key]['product_price_with_tax']);
                    // unset($test['products'][$key]['product_price_tax']);
                }
            }
          
            $response = $this->client->post(
                $this->test_url . $this->endpoint,
                [
                    'headers' => ['Content-Type' => 'application/json', 'Authorization' => 'Bearer ' . $token, 'verify' => false],
                    'body' => $data,
                    'connect_timeout' => 5, // Connection timeout,
                    'verify' => false,
                    'exceptions' => false,
                    'http_errors' => false

                ],
            );
         
            // var_dump($this->test_url . $this->endpoint);
            // var_dump($response->getStatusCode());
            // exit();
           
            
            
            if ($response && $response->getStatusCode() == 200) {
                
                $data = json_decode($response->getBody());
               
                if (!$data->errors && $data->validityResult == 'VALID') {
                    if ($this->widget_rate == 1) {
                        $price = $data->firstInstallment->value;
                    }
                    $status = true;
                } else {
                    $status = false;
                }
             
                
                if ($this->enable == "0") {
                    return false;
                }
              
                if ($type == 'ITEM' && $this->widgetproduct == '0') {
                    return false;
                }
                if ($type == 'BASKET' && $this->widgetcart == '0') {
                    return false;
                }
                
                if ($type == 'BASKET' && $discounts) {
                    return false;
                }
                if ($type == 'BASKET' && (int)$cart->getQuote()->getShippingAddress()->getShippingAmount() > 0) {
                    // return false
                }
                if ($type == 'ORDER' && $this->order == 0) {
                    return false;
                }


                
               
              
                //fake data
                // $status = true;
                // $price = 10.00;
                if ($this->widget_style == '1') {
                    $color_style = 'blue';
                } else if ($this->widget_style == '0') {
                    $color_style = 'white';
                }

                if ($this->widget_size == '2') {
                    $size_style = 'xxl';
                } else if ($this->widget_size == '1') {
                    $size_style = 'big';
                } else {
                    $size_style = 'medium';
                }


               
                $file = 'pko_' . $size_style . '_' . $color_style . '_leasing.' . ($size_style == 'xxl' ? 'webp' : 'svg');

                if ($size_style == 'big' && $color_style !== 'blue' && $this->widget_rate == 0) {
                    $file = 'pko_' . $size_style . '_' . $color_style . '_leasing.webp';
                }
               
                
                $disabled = false;
                $img_styles = '';
                if ($status == false) {
                    $show_rates = 0;
                    $file = 'pko_disabled_' . $size_style . '_leasing.' . ($size_style == 'xxl' ? 'webp' : 'svg');
                    if ($size_style == 'big' || $size_style == 'xxl') {
                        $img_styles = 'border: 1px solid #E6E6E6;border-radius:4px;';
                    }
                }
               
                $text = '';
                $class = '';
                if ($color_style !== 'blue') {
                    $border = '';
                    $class = 'white';
                }
              
                if ($this->widget_rate == 1 && $status == true && $price) {
                   
                    if ($color_style == 'blue') {
                        $color = '#fff';
                        $border = '';
                    } else {
                        $color = '#000';
                        $border = '';
                    }
                    if ($size_style == 'big') {

                        $styles = 'style="' . $border . 'position:absolute;right:4px;top:17px;line-height:17px;width:70px;display:inline-block;font-size:14px;font-family:pkobp;color:' . $color . '"';
                        $file = str_replace('.svg', '_raty.webp', $file);
                    } else if ($size_style == 'xxl') {
                        $styles = 'style="' . $border . 'position:absolute;right:5px;top:20px;line-height:17px;width:80px;display:inline-block;font-size:15px;font-family:pkobp;color:' . $color . '"';
                        $file = str_replace('.webp', '_raty.webp', $file);
                    } elseif ($size_style == 'medium') {
                        $styles = 'style="' . $border . 'position: absolute;right: -9px;top: 13px;line-height: 14px;width: 70px;display: inline-block;font-size: 12px;font-family: pkobp;color:' . $color . '"';
                        $file = str_replace('.svg', '_raty.webp', $file);
                    } else {
                        $styles = 'style="' . $border . 'position: absolute;right: -12px;top: 11px;line-height: 12px;width: 60px;display: inline-block;font-size: 11px;font-family: pkobp;color: #000;color:' . $color . '"';
                        $file = str_replace('.svg', '_raty.webp', $file);
                    }

                    $text .= '<span class="pko_rate" ' . $styles . '>Rata od<br/> ' . sprintf('%0.2f', $price) . ' zł</span>';
                }

             
                if ($status == true) {
                    //$action = 'document.getElementById("pkol_form").submit()';

                    $response = '<div class="pkol_widget" ><div data-baseurl="" data-pid="' . $pid . '" id="lease_click"  style="display:inline-block;position:relative;">' . $text . '<img class="' . $class . '" src="' . $this->_path . '' . $file . '" /></div></div><style>.modal-body .pkol_widget,.modal-body .pko_container,.modal-footer .pkol_widget,.modal-footer .pko_container {display:none!important;} #lease_click:hover {cursor:pointer;}</style>';
                    $render_form = $this->getForm($type, $default_data, $url);

                    return ['status' => true, 'response' => $response, 'form' => $render_form];
                    // return '<br><br><div class="pkol_widget" ><div data-baseurl="" data-pid="' . $id . '" id="lease_click"  style="display:inline-block;position:relative;">' . $text . '<img class="'.$class.'" src="'.$this->_path.'' . $file . '" /></div></div><style>#lease_click:hover {cursor:pointer;}</style>';
                } else {
                
                    $response = $this->_path . '' . $file;
                    return ['status' => false, 'response' => '<div><img src="' . $response . '" /></div>', 'form' => null];
                }
            } else {
                $status = false;
                if ($this->widget_style == '1') {
                    $color_style = 'blue';
                } else if ($this->widget_style == '0') {
                    $color_style = 'white';
                }

                if ($this->widget_size == '2') {
                    $size_style = 'xxl';
                } else if ($this->widget_size == '1') {
                    $size_style = 'big';
                } else {
                    $size_style = 'medium';
                }


               
                $file = 'pko_' . $size_style . '_' . $color_style . '_leasing.' . ($size_style == 'xxl' ? 'webp' : 'svg');

                if ($size_style == 'big' && $color_style !== 'blue' && $this->widget_rate == 0) {
                    $file = 'pko_' . $size_style . '_' . $color_style . '_leasing.webp';
                }
               
                
                $disabled = false;
                $img_styles = '';
                if ($status == false) {
                    $show_rates = 0;
                    $file = 'pko_disabled_' . $size_style . '_leasing.' . ($size_style == 'xxl' ? 'webp' : 'svg');
                    if ($size_style == 'big' || $size_style == 'xxl') {
                        $img_styles = 'border: 1px solid #E6E6E6;border-radius:4px;';
                    }
                }
               

                 $response = $this->_path . '' . $file;
                 return ['status' => false, 'response' => '<div><img src="' . $response . '" /></div>', 'form' => null];
            }
        } else {
            $price = null;
            $status = false;
            $status = false;
                if ($this->widget_style == '1') {
                    $color_style = 'blue';
                } else if ($this->widget_style == '0') {
                    $color_style = 'white';
                }

                if ($this->widget_size == '2') {
                    $size_style = 'xxl';
                } else if ($this->widget_size == '1') {
                    $size_style = 'big';
                } else {
                    $size_style = 'medium';
                }


               
                $file = 'pko_' . $size_style . '_' . $color_style . '_leasing.' . ($size_style == 'xxl' ? 'webp' : 'svg');

                if ($size_style == 'big' && $color_style !== 'blue' && $this->widget_rate == 0) {
                    $file = 'pko_' . $size_style . '_' . $color_style . '_leasing.webp';
                }
               
                
                $disabled = false;
                $img_styles = '';
                if ($status == false) {
                    $show_rates = 0;
                    $file = 'pko_disabled_' . $size_style . '_leasing.' . ($size_style == 'xxl' ? 'webp' : 'svg');
                    if ($size_style == 'big' || $size_style == 'xxl') {
                        $img_styles = 'border: 1px solid #E6E6E6;border-radius:4px;';
                    }
                }
               

                 $response = $this->_path . '' . $file;
                 return ['status' => false, 'response' => '<div><img src="' . $response . '" /></div>', 'form' => null];
            
        }






        $pid = 6;
        $type = 'ITEM';
    }
    public function execute()
    {
        $pid = $_POST['pid'];
       
        $type = 'ITEM';
      
        if (isset($_POST['type'])) {
            if ($_POST['type'] == 'ITEM') {
                $tmp = [];
                $type = (string)$_POST['type'];
                $pid = (int)$_POST['pid'];
               
                // array_push($tmp, $pid);
                $response = $this->validateProducts('ITEM', $pid);
            } else if ($_POST['type'] == 'BASKET') {
                $response = $this->validateProducts('BASKET', $pid);
            }
            echo json_encode(['data' => $response]);
            exit();
        }
        // TODO: Implement execute() method.

        //echo $this->helper->getGeneralConfig('shopID');
        //echo $this->helper->getGeneralConfig('secretkey');
        exit();
    }
}
