<?php
 
namespace Pkol\Leasing\Model;
use \Magento\Tax\Model\Calculation\Rate;
 
class Taxrate extends \Magento\Framework\DataObject 
    implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var Rate
     */
    protected $_taxModelConfig;
     
    /**
     * @param Rate               $taxModelConfig
     */
    public function __construct(
        Rate $taxModelConfig
    ) {
        $this->_taxModelConfig = $taxModelConfig;
    }
  
    public function toOptionArray()
    {
        $taxRates = $this->_taxModelConfig->getCollection()->getData();
        $taxArray = array();
        foreach ($taxRates as $tax) {
            $taxRateId = $tax['tax_calculation_rate_id'];
            $taxCode = $tax["code"];
            $taxRate = $tax["rate"];
            $taxName = $taxCode.'('.$taxRate.'%)';
            $taxArray[$taxRateId] = $taxName;
        }
        return $taxArray;
    }
}