<?php

namespace Pkol\Leasing\Observer;

use Magento\Framework\Event\ObserverInterface;
use Pkol\Leasing\Model\Taxrate;
use \Magento\Tax\Model\Calculation\Rate;


class Paymentmethoddisable implements ObserverInterface
{
    
    public $helper;
    protected $helperData;
    public $shopid;
    public $secretkey;
    public $env;
    public $widget_style;
    public $widget_size;
    public $widget_rate;
    public $client;
    public $_path;
    public $endpoint;
    public $test_url;
    public $prod_url;
    public $lease_url;
    public $app_status;
    public $enable;
    protected $dataHelper;
    public $widgetorder;
    public $widgetcart;
    public $widgetproduct;

    public function __construct(
        \Magento\Framework\Event\Observer $observer,
        \Pkol\Leasing\Helper\Data $helperData
    ) {
        
        $this->dataHelper = $helperData;
        $this->helper = $helperData;
        $this->shopid = $helperData->getGeneralConfig('shopID');
        $this->secretkey = $helperData->getGeneralConfig('secretKey');
        $this->env = $helperData->getGeneralConfig('env');
        $this->prod_url = 'https://pc.pkoleasing.pl';
        $this->test_url = 'https://stpc.pkoleasing.pl';
        $this->lease_url = '/leasing/init';
        $this->endpoint = '/leasing/public/plugin/simulation';
        $this->app_status = true;
        $this->widgetproduct = $helperData->getGeneralConfig('widgetproduct');
        $this->widgetorder = $helperData->getGeneralConfig('widgetorder');
        $this->widgetcart = $helperData->getGeneralConfig('widgetcart');
        $this->widget_style = $helperData->getGeneralConfig('widgetstyle');
        $this->widget_size = $helperData->getGeneralConfig('widgetsize');
        $this->widget_rate = $helperData->getGeneralConfig('widgetrate');
        $this->enable = $helperData->getGeneralConfig('enable');
        if ($this->env == 0) {
            $this->lease_url = $this->test_url . $this->lease_url;
        } else {
            $this->lease_url = $this->prod_url . $this->lease_url;
            $this->test_url = $this->prod_url;
        }
       
    }
    public function getRate($tax)
    {
        $tax = explode('.', $tax);
        $taxes = [
            '0%' => 1,
            '7%' => 2,
            '8%' => 3,
            '22%' => 4,
            '23%' => 5,
            '23' => 5,
            '22' => 4,
            '8' => 3,
            '7' => 2,
            '0' => 1
        ];
        $tax = $tax[0];

        if (isset($taxes[$tax])) {
            return $taxes[$tax];
        } else {
            return null;
        }
    }
    public function validateProducts() {
                //Prepare token
                $settings_token = $this->shopid . ':' . $this->secretkey;
                $token = base64_encode($settings_token);
                $this->client = new \GuzzleHttp\Client([
                    'verify' => false,
                    'exceptions ' => false,
                    'headers' => ['Content-Type' => 'application/json', 'Authorization' => 'Bearer ' . $token, 'verify' => false]
                ]);
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();

                //Check and prepare products 
                $cart = $objectManager->get('\Magento\Checkout\Model\Cart');
                // retrieve quote items collection
                $itemsCollection = $cart->getQuote()->getItemsCollection();
                $discounts = $cart->getQuote()->getAppliedRuleIds();
                $items = $cart->getQuote()->getAllItems();
                $products = [];
                $total = 0;
                
                foreach ($items as $item) {
                    $pid = $item->getProductId();
                   
                    $price_wtax = $item->getPrice();
                    $product = $objectManager->create('Magento\Catalog\Model\Product')->load($pid);
                    if ($product->getTypeId() !== 'simple') {
                        return false;
                    }
                    $product_name = $product->getName();
                    $stockItem = $product->getExtensionAttributes()->getStockItem();
                    $stockQty = $stockItem->getQty(); // $stockItemData = $stockItem->getData();
                    $url = $product->getProductUrl();
                    $category = $product->getCategoryIds();
                    $product_category = $category[0];
                    // product tax class id
                    $tax_class_id = $product->getTaxClassId();
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $priceWithTax = $product->getPriceInfo()->getPrice('final_price')->getMinimalPrice()->getValue();

                    $priceWithoutTaxNotRound = number_format((float)$product->getPriceInfo()->getPrice('final_price')->getAmount()->getBaseAmount(),2,'.','');
                    $priceWithTaxNotRound = number_format((float)$product->getPriceInfo()->getPrice('final_price')->getAmount()->getValue(), 2, '.','');
                    
                    // echo '<pre>';
                    // var_dump($product->getPriceInfo()->getPrice('final_price')->getAmount()->getTax());
                    // echo '</pre>';
                
                    $tax = (($priceWithTaxNotRound * 100) / $priceWithoutTaxNotRound) - 100;
                    $tax_rate = round($tax);

                    $rate = $this->getRate($tax_rate);
                    $taxParameter = (100 + (int)$tax_rate) / 100;
                    $priceWithoutTax = str_replace(',', '', round($priceWithTax / $taxParameter, 2));
                    $tmp = [
                        'categoryId' =>  $product_category,
                        'netValue' => str_replace(',', '', number_format($priceWithoutTax, 2)),
                        'vatRate' => $rate,
                        'quantity' => (int)$item->getQty(),
                        'product_name' => $product_name,
                        'product_price_with_tax' => $priceWithTax,
                        'product_price_tax' => $taxParameter
                   ];
                    array_push($products, $tmp);


                $total = $total + (str_replace(',', '', number_format($priceWithoutTax, 2)) * (int)$item->getQty());
                }
                $test = [
                    'shopId' => $this->shopid,
                    'widgetOption' => 1,
                    'totalNetValue' =>  $total,
                    'uniqueItemQuantity' => count($products),
                    'source' => 'BASKET',
                    'products' => $products
                ];
                $data =  json_encode($test);

                $check_vat = json_decode($data);
                $taxRate = true;

                foreach ($check_vat->products as $v) {

                    if ($v->vatRate == null) {
                        $taxRate = false;
                    }
                }
                $status = false;
                if ($taxRate) { 
                    $response = $this->client->post(
                        $this->test_url . $this->endpoint,
                        [
                            'headers' => ['Content-Type' => 'application/json', 'Authorization' => 'Bearer ' . $token, 'verify' => false],
                            'body' => $data,
                            'connect_timeout' => 5, // Connection timeout,
                            'verify' => false,
                            'exceptions' => false,
                            'http_errors' => false
        
                        ],
                    );
                    if ($response && $response->getStatusCode() == 200) {

                        $data = json_decode($response->getBody());
                        if (!$data->errors && $data->validityResult == 'VALID') {
                            $status = true;
                        } else {
                            $status = false;
                        }
                    } else {
                        $status = false;
                    }
                }
                return $status;

    }

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        // 
        
   
        if($observer->getEvent()->getMethodInstance()->getCode() == "custompayment"){  // Here you can replace required payment method code
            $checkResult = $observer->getEvent()->getResult();
            $show_button  = true;

            if ( $this->widgetorder == '0') {
                $show_button = false;               
            } 
            if ($this->enable == "0") {
                $show_button = false;       
            }
            $check_products = $this->validateProducts();
            if (!$check_products) {
                $show_button = false;      
            }

            if (!$show_button) {
                $checkResult->setData('is_available', false);
            }
        }
    }
}